/* Generated by wayland-scanner 1.13.0 */

#ifndef QTKEY_EXTENSION_SERVER_PROTOCOL_H
#define QTKEY_EXTENSION_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_qtkey_extension The qtkey_extension protocol
 * @section page_ifaces_qtkey_extension Interfaces
 * - @subpage page_iface_qt_key_extension - 
 * @section page_copyright_qtkey_extension Copyright
 * <pre>
 *
 * Copyright (C) 2015 The Qt Company Ltd.
 * Contact: http://www.qt.io/licensing/
 *
 * This file is part of the plugins of the Qt Toolkit.
 *
 * $QT_BEGIN_LICENSE:BSD$
 * You may use this file under the terms of the BSD license as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 * </pre>
 */
struct qt_key_extension;
struct wl_surface;

/**
 * @page page_iface_qt_key_extension qt_key_extension
 * @section page_iface_qt_key_extension_api API
 * See @ref iface_qt_key_extension.
 */
/**
 * @defgroup iface_qt_key_extension The qt_key_extension interface
 */
extern const struct wl_interface qt_key_extension_interface;

/**
 * @ingroup iface_qt_key_extension
 * @struct qt_key_extension_interface
 */
struct qt_key_extension_interface {
	/**
	 */
	void (*dummy)(struct wl_client *client,
		      struct wl_resource *resource);
};

#define QT_KEY_EXTENSION_QTKEY 0

/**
 * @ingroup iface_qt_key_extension
 */
#define QT_KEY_EXTENSION_QTKEY_SINCE_VERSION 1

/**
 * @ingroup iface_qt_key_extension
 */
#define QT_KEY_EXTENSION_DUMMY_SINCE_VERSION 1

/**
 * @ingroup iface_qt_key_extension
 * Sends an qtkey event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
qt_key_extension_send_qtkey(struct wl_resource *resource_, struct wl_resource *surface, uint32_t time, uint32_t type, uint32_t key, uint32_t modifiers, uint32_t nativeScanCode, uint32_t nativeVirtualKey, uint32_t nativeModifiers, const char *text, uint32_t autorepeat, uint32_t count)
{
	wl_resource_post_event(resource_, QT_KEY_EXTENSION_QTKEY, surface, time, type, key, modifiers, nativeScanCode, nativeVirtualKey, nativeModifiers, text, autorepeat, count);
}

#ifdef  __cplusplus
}
#endif

#endif
