#include "qwayland-drm-egl-server-buffer.h"

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWayland {
    qt_drm_egl_server_buffer::qt_drm_egl_server_buffer(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_drm_egl_server_buffer::qt_drm_egl_server_buffer(struct ::qt_drm_egl_server_buffer *obj)
        : m_qt_drm_egl_server_buffer(obj)
    {
        init_listener();
    }

    qt_drm_egl_server_buffer::qt_drm_egl_server_buffer()
        : m_qt_drm_egl_server_buffer(0)
    {
    }

    qt_drm_egl_server_buffer::~qt_drm_egl_server_buffer()
    {
    }

    void qt_drm_egl_server_buffer::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_drm_egl_server_buffer = static_cast<struct ::qt_drm_egl_server_buffer *>(wl_registry_bind(registry, id, &qt_drm_egl_server_buffer_interface, version));
        init_listener();
    }

    void qt_drm_egl_server_buffer::init(struct ::qt_drm_egl_server_buffer *obj)
    {
        m_qt_drm_egl_server_buffer = obj;
        init_listener();
    }

    bool qt_drm_egl_server_buffer::isInitialized() const
    {
        return m_qt_drm_egl_server_buffer != 0;
    }

    const struct wl_interface *qt_drm_egl_server_buffer::interface()
    {
        return &::qt_drm_egl_server_buffer_interface;
    }

    void qt_drm_egl_server_buffer::drm_egl_server_buffer_server_buffer_created(struct ::qt_server_buffer *, int32_t , int32_t , int32_t , int32_t , int32_t )
    {
    }

    void qt_drm_egl_server_buffer::handle_server_buffer_created(
        void *data,
        struct ::qt_drm_egl_server_buffer *object,
        struct ::qt_server_buffer *id,
        int32_t name,
        int32_t width,
        int32_t height,
        int32_t stride,
        int32_t format)
    {
        Q_UNUSED(object);
        static_cast<qt_drm_egl_server_buffer *>(data)->drm_egl_server_buffer_server_buffer_created(
            id,
            name,
            width,
            height,
            stride,
            format);
    }

    const struct qt_drm_egl_server_buffer_listener qt_drm_egl_server_buffer::m_qt_drm_egl_server_buffer_listener = {
        qt_drm_egl_server_buffer::handle_server_buffer_created
    };

    void qt_drm_egl_server_buffer::init_listener()
    {
        qt_drm_egl_server_buffer_add_listener(m_qt_drm_egl_server_buffer, &m_qt_drm_egl_server_buffer_listener, this);
    }
}

QT_WARNING_POP
QT_END_NAMESPACE
