#include "qwayland-xcomposite.h"

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWayland {
    qt_xcomposite::qt_xcomposite(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_xcomposite::qt_xcomposite(struct ::qt_xcomposite *obj)
        : m_qt_xcomposite(obj)
    {
        init_listener();
    }

    qt_xcomposite::qt_xcomposite()
        : m_qt_xcomposite(0)
    {
    }

    qt_xcomposite::~qt_xcomposite()
    {
    }

    void qt_xcomposite::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_xcomposite = static_cast<struct ::qt_xcomposite *>(wl_registry_bind(registry, id, &qt_xcomposite_interface, version));
        init_listener();
    }

    void qt_xcomposite::init(struct ::qt_xcomposite *obj)
    {
        m_qt_xcomposite = obj;
        init_listener();
    }

    bool qt_xcomposite::isInitialized() const
    {
        return m_qt_xcomposite != 0;
    }

    const struct wl_interface *qt_xcomposite::interface()
    {
        return &::qt_xcomposite_interface;
    }

    struct ::wl_buffer *qt_xcomposite::create_buffer(uint32_t x_window, int32_t width, int32_t height)
    {
        return qt_xcomposite_create_buffer(
            m_qt_xcomposite,
            x_window,
            width,
            height);
    }

    void qt_xcomposite::xcomposite_root(const QString &, uint32_t )
    {
    }

    void qt_xcomposite::handle_root(
        void *data,
        struct ::qt_xcomposite *object,
        const char *display_name,
        uint32_t root_window)
    {
        Q_UNUSED(object);
        static_cast<qt_xcomposite *>(data)->xcomposite_root(
            QString::fromUtf8(display_name),
            root_window);
    }

    const struct qt_xcomposite_listener qt_xcomposite::m_qt_xcomposite_listener = {
        qt_xcomposite::handle_root
    };

    void qt_xcomposite::init_listener()
    {
        qt_xcomposite_add_listener(m_qt_xcomposite, &m_qt_xcomposite_listener, this);
    }
}

QT_WARNING_POP
QT_END_NAMESPACE
