/* Generated by wayland-scanner 1.13.0 */

#ifndef DRM_EGL_SERVER_BUFFER_SERVER_PROTOCOL_H
#define DRM_EGL_SERVER_BUFFER_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_drm_egl_server_buffer The drm_egl_server_buffer protocol
 * @section page_ifaces_drm_egl_server_buffer Interfaces
 * - @subpage page_iface_qt_drm_egl_server_buffer - 
 * @section page_copyright_drm_egl_server_buffer Copyright
 * <pre>
 *
 * Copyright (C) 2015 The Qt Company Ltd.
 * Contact: http://www.qt.io/licensing/
 *
 * This file is part of the plugins of the Qt Toolkit.
 *
 * $QT_BEGIN_LICENSE:BSD$
 * You may use this file under the terms of the BSD license as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 * </pre>
 */
struct qt_drm_egl_server_buffer;
struct qt_server_buffer;

/**
 * @page page_iface_qt_drm_egl_server_buffer qt_drm_egl_server_buffer
 * @section page_iface_qt_drm_egl_server_buffer_api API
 * See @ref iface_qt_drm_egl_server_buffer.
 */
/**
 * @defgroup iface_qt_drm_egl_server_buffer The qt_drm_egl_server_buffer interface
 */
extern const struct wl_interface qt_drm_egl_server_buffer_interface;

#ifndef QT_DRM_EGL_SERVER_BUFFER_FORMAT_ENUM
#define QT_DRM_EGL_SERVER_BUFFER_FORMAT_ENUM
enum qt_drm_egl_server_buffer_format {
	QT_DRM_EGL_SERVER_BUFFER_FORMAT_RGBA32 = 0,
	QT_DRM_EGL_SERVER_BUFFER_FORMAT_A8 = 1,
};
#endif /* QT_DRM_EGL_SERVER_BUFFER_FORMAT_ENUM */

#define QT_DRM_EGL_SERVER_BUFFER_SERVER_BUFFER_CREATED 0

/**
 * @ingroup iface_qt_drm_egl_server_buffer
 */
#define QT_DRM_EGL_SERVER_BUFFER_SERVER_BUFFER_CREATED_SINCE_VERSION 1


/**
 * @ingroup iface_qt_drm_egl_server_buffer
 * Sends an server_buffer_created event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
qt_drm_egl_server_buffer_send_server_buffer_created(struct wl_resource *resource_, struct wl_resource *id, int32_t name, int32_t width, int32_t height, int32_t stride, int32_t format)
{
	wl_resource_post_event(resource_, QT_DRM_EGL_SERVER_BUFFER_SERVER_BUFFER_CREATED, id, name, width, height, stride, format);
}

#ifdef  __cplusplus
}
#endif

#endif
