#include "qwayland-ivi-application.h"

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")

namespace QtWayland {
    ivi_surface::ivi_surface(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    ivi_surface::ivi_surface(struct ::ivi_surface *obj)
        : m_ivi_surface(obj)
    {
        init_listener();
    }

    ivi_surface::ivi_surface()
        : m_ivi_surface(0)
    {
    }

    ivi_surface::~ivi_surface()
    {
    }

    void ivi_surface::init(struct ::wl_registry *registry, int id, int version)
    {
        m_ivi_surface = static_cast<struct ::ivi_surface *>(wl_registry_bind(registry, id, &ivi_surface_interface, version));
        init_listener();
    }

    void ivi_surface::init(struct ::ivi_surface *obj)
    {
        m_ivi_surface = obj;
        init_listener();
    }

    bool ivi_surface::isInitialized() const
    {
        return m_ivi_surface != 0;
    }

    const struct wl_interface *ivi_surface::interface()
    {
        return &::ivi_surface_interface;
    }

    void ivi_surface::destroy()
    {
        ivi_surface_destroy(
            m_ivi_surface);
        m_ivi_surface = 0;
    }

    void ivi_surface::ivi_surface_configure(int32_t , int32_t )
    {
    }

    void ivi_surface::handle_configure(
        void *data,
        struct ::ivi_surface *object,
        int32_t width,
        int32_t height)
    {
        Q_UNUSED(object);
        static_cast<ivi_surface *>(data)->ivi_surface_configure(
            width,
            height);
    }

    const struct ivi_surface_listener ivi_surface::m_ivi_surface_listener = {
        ivi_surface::handle_configure
    };

    void ivi_surface::init_listener()
    {
        ivi_surface_add_listener(m_ivi_surface, &m_ivi_surface_listener, this);
    }

    ivi_application::ivi_application(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    ivi_application::ivi_application(struct ::ivi_application *obj)
        : m_ivi_application(obj)
    {
    }

    ivi_application::ivi_application()
        : m_ivi_application(0)
    {
    }

    ivi_application::~ivi_application()
    {
    }

    void ivi_application::init(struct ::wl_registry *registry, int id, int version)
    {
        m_ivi_application = static_cast<struct ::ivi_application *>(wl_registry_bind(registry, id, &ivi_application_interface, version));
    }

    void ivi_application::init(struct ::ivi_application *obj)
    {
        m_ivi_application = obj;
    }

    bool ivi_application::isInitialized() const
    {
        return m_ivi_application != 0;
    }

    const struct wl_interface *ivi_application::interface()
    {
        return &::ivi_application_interface;
    }

    struct ::ivi_surface *ivi_application::surface_create(uint32_t ivi_id, struct ::wl_surface *surface)
    {
        return ivi_application_surface_create(
            m_ivi_application,
            ivi_id,
            surface);
    }
}

QT_WARNING_POP
QT_END_NAMESPACE
